#extension GL_OES_EGL_image_external : require
#define KERNEL_SIZE 9
precision highp float;
varying vec2 textureCoordinate;
uniform samplerExternalOES sTexture;
uniform float uKernel[KERNEL_SIZE];
uniform vec2 uTexOffset[KERNEL_SIZE];
uniform float uColorAdjust;
void main() {
    int i = 0;
    vec4 sum = vec4(0.0);
    for (i = 0; i < KERNEL_SIZE; i++) {
          vec4 texc = texture2D(sTexture, textureCoordinate + uTexOffset[i]);
          sum += texc * uKernel[i];
         }
    gl_FragColor = sum;
}